' HRDiag.inc         Stand: 18.11.2002
' Zur Erzeugung von "Tortendiagrammen" mit Profan ab 5.0

Proc PieChartLegend
  Parameters pchartlegx%,pchartlegy%,pchartlegcaption$,pchartlegcolor&
  UsePen 0,1,pchartlegcolor&
  UseBrush 1,pchartlegcolor&
  RectAngle pchartlegx%,pchartlegy%-@Add(pchartlegx%,25),@Add(pchartlegy%,15)
  UseFont "MS Sans Serif",10,0,0,0,0
  SetDialogfont 1
  DrawText @Add(pchartlegx%,30),pchartlegy%,pchartlegcaption$
  Decimals 1
EndProc

Proc PieChartComplete
  ' Aufrufparameter:
  ' X1,Y1,X2,Y2,StartProzent,AnzeigeProzentWert,Farbe(RGB),CaptionText,CaptionPosition
  ' Zu CaptionPosition: wenn der Wert negativ ist, wird der Prozentwert in Klammern angehngt
  Declare pchartssin!,pchartscos!,pchartesin!,pchartecos!,pchartedge!,pchartradius!
  Parameters pchartstartx%,pchartstarty%,pchartendx%,pchartendy%,pchartstartval!,pchartendval!,pchartcolor&,pchartcaption$,pchartcaptpos%
  let pchartedge!=@Add(@Div(@Sub(pchartendx%,pchartstartx%),2),pchartstartx%)
  let pchartradius!=@Div(@Sub(pchartendx%,pchartstartx%),2)
  If @Lt(pchartcaptpos%,0)
    let pchartcaption$=pchartcaption$,@Format$("(##0.0#%)",pchartendval!)
    let pchartcaptpos%=@Mul(pchartcaptpos%,-1)
  EndIf
  let pchartendval!=@Add(pchartstartval!,pchartendval!)
  let pchartssin!=@Add(@Mul(@Sin(@Div(@Mul(@Mul(pchartstartval!,3.6),@Pi()),180)),pchartradius!),pchartedge!)
  let pchartscos!=@Add(@Mul(@Cos(@Div(@Mul(@Mul(pchartstartval!,3.6),@Pi()),180)),pchartradius!),pchartedge!)
  let pchartesin!=@Add(@Mul(@Sin(@Div(@Mul(@Mul(pchartendval!,3.6),@Pi()),180)),pchartradius!),pchartedge!)
  let pchartecos!=@Add(@Mul(@Cos(@Div(@Mul(@Mul(pchartendval!,3.6),@Pi()),180)),pchartradius!),pchartedge!)
  UsePen 0,1,pchartcolor&
  UseBrush 1,pchartcolor&
  Pie pchartstartx%,pchartstarty%-pchartendx%,pchartendy%;pchartssin!,pchartscos!;pchartesin!,pchartecos!
  If @Neq$(pchartcaption$,"")
    Declare pchartcaptx%,pchartcapty%
    let PChartCaptX%=@Add(pchartendx%,30)
    let PChartCaptY%=@Sub(@Add(pchartstarty%,@Mul(pchartcaptpos%,30)),30)
    RectAngle PChartCaptX%,PChartCaptY%-@Add(PChartCaptX%,25),@Add(PChartCaptY%,15)
    DrawText @Add(PChartCaptX%,30),PChartCaptY%,pchartcaption$
  EndIf
EndProc

Proc PieChartElement
  ' Aufrufparameter:
  ' Startkoordinaten (durch Kommata getrennt!),StartProzent,EndProzent,Farbe(RGB)
  Declare pchartssin!,pchartscos!,pchartesin!,pchartecos!,pchartedge!,pchartradius!
  Parameters pchartstartx%,pchartstarty%,pchartendx%,pchartendy%,pchartstartval!,pchartendval!,pchartcolor&
  let pchartedge!=@Add(@Div(@Sub(pchartendx%,pchartstartx%),2),pchartstartx%)
  let pchartradius!=@Div(@Sub(pchartendx%,pchartstartx%),2)
  let pchartendval!=@Add(pchartstartval!,pchartendval!)
  let pchartssin!=@Add(@Mul(@Sin(@Div(@Mul(@Mul(pchartstartval!,3.6),@Pi()),180)),pchartradius!),pchartedge!)
  let pchartscos!=@Add(@Mul(@Cos(@Div(@Mul(@Mul(pchartstartval!,3.6),@Pi()),180)),pchartradius!),pchartedge!)
  let pchartesin!=@Add(@Mul(@Sin(@Div(@Mul(@Mul(pchartendval!,3.6),@Pi()),180)),pchartradius!),pchartedge!)
  let pchartecos!=@Add(@Mul(@Cos(@Div(@Mul(@Mul(pchartendval!,3.6),@Pi()),180)),pchartradius!),pchartedge!)
  UsePen 0,1,pchartcolor&
  UseBrush 1,pchartcolor&
  Pie pchartstartx%,pchartstarty%-pchartendx%,pchartendy%;pchartssin!,pchartscos!;pchartesin!,pchartecos!
EndProc

